#include <pic.h>
#include "lcd.h"
#include "eeprom.h"
#define RC5 RB4
unsigned int GetRc5(void);
void SetRc5(void);
void wys_hex(unsigned char dana,char x, char y );

unsigned int rc5_zal1, rc5_odl1, rc5_zal2, rc5_odl2;

struct{
   char tms:1;
}bits;
#define tms bits.tms

unsigned int mSec,uSec;
//obsuga przerwnia od Timer - odliczanie opnie
static void interrupt
isr(void)         		// przerwanie od Timer0
{
   if(T0IF){             //zerowan ie flagi przerwania
      TMR0+=131;         //8MHz/4/16/125=1kHz T=1msek
      if(tms){
      --mSec;
      if(mSec==0)
      tms=0;
      }
      T0IF = 0;         // clear the interrupt flag
   }
}
void main (void){
unsigned int kod;
	TRISD=0;
	TRISC=0x0f;
	PORTC=0;
	OPTION=0b00000011;//ustawienie TMR0
	ANSELH=0;		//PORTB cyfrowy
	T0IE = 1;		// odblokowanie przerwania od przepelnienia TMR0
	GIE = 1;		// odblokowanie systemu przerwa
	InicLcd();
	if(read_eeprom(8)!=0x55)
	SetRc5();
	else
	{rc5_zal1=read_eeprom(0);
	 rc5_zal1=(rc5_zal1<<8)|read_eeprom(1);
	 rc5_odl1=read_eeprom(2);
	 rc5_odl1=(rc5_odl1<<8)|read_eeprom(3);
	 rc5_zal2=read_eeprom(4);
	 rc5_zal2=(rc5_zal2<<8)|read_eeprom(5);
	 rc5_odl2=read_eeprom(6);
	 rc5_odl2=(rc5_odl2<<8)|read_eeprom(7);
	}
	ClrLcd();
	PosLcd(1,1);	
	DispLcd("Kod RC5");
	while(1){
	while(RC5==1);
	kod=GetRc5();
	wys_hex((kod>>8),0x09,1);//kod rc5 w postaci hex
	wys_hex(kod,0x0b,1);
	PosLcd(1,2);
	if(kod==rc5_zal1)
	{DispLcd("ZAL1");
	 PORTC=0x10;
	}
	if(kod==rc5_odl1)
	{DispLcd("ODL1");
	 PORTC=0x20;
	}
	if(kod==rc5_zal2)
	{DispLcd("ZAL2");
	 PORTC=0x40;
	}
	if(kod==rc5_odl2)
	{DispLcd("ODL2");
	PORTC=0x80;
	}
	DispLcd("     ");
	}

}

//**********************************************************************
//procedura odbierania kodu RC5. Na 8 starszych bitach zwracanego kodu 
//jest sowo systemu, a na 8 modszych sowo komendy
//**********************************************************************

unsigned int GetRc5(void)
{
unsigned char i,c_rc5,inrc5;
unsigned int c_crc5;
unsigned int tm;

	while(RC5==0)//czekaj na poczatek odbioru kodu RC5
	asm("nop");asm("nop");asm("nop");asm("nop");
	c_rc5=0;
	c_crc5=0;
	for(i=0;i<13;i++)
	{
	 if(RC5==0)
	 inrc5=0;
	 else
	 inrc5=1;
	T0IE=0;//zablokuj przerwania od TMR0
	while(T0IF==1);//czekaj na zerowanie flagi - zakoczenie przewania
	TMR0=5;//czekaj ok 2msek
	while(1)
	{
	  if(T0IF==1)
	  return (0xffff);//powrt z bledem
	 
	  if((RC5==0)&&(inrc5==1))//opadajce zbocze?
	   {c_rc5=c_rc5<<1;
	    c_rc5=c_rc5|1;//wstaw 1
	    break;}
	  if((RC5==1)&&(inrc5==0))//narastajce zbocze
	    {c_rc5=c_rc5<<1;//przesu i wstaw 0
	    break;}
	}
	T0IF=0;
	T0IE=1;
	if(i==6)
	{c_crc5=(c_rc5&0x5f);//6bitw adres
	c_crc5=c_crc5<<8;
	c_rc5=0;}
	delay_ms(1);
	}
	c_crc5=(c_crc5|c_rc5);//zapisanie komendy
	return(c_crc5);
}
//**********************************************************************
//funkcja uczenia sterownika 4 kodw ZAL1, WYL1, ZAL2 i WYL2
//**********************************************************************
void SetRc5(void)
{
unsigned int kod;
	ClrLcd();
	PosLcd(1,1);
	DispLcd("kod RC5     ");
	PosLcd(1,2);
	DispLcd("ZAL1 ----    ");//zapamietanie kodu ZAL1
	while(RC5==1);//czekaj na poczatek kodu
	while(1){
	kod=GetRc5();
	if(kod!=0xffff)
	break;
	}
	wys_hex((kod>>8),6,2);//kod rc5 w postaci hex
	wys_hex(kod,8,2);
	write_eeprom(0,kod>>8);
	write_eeprom(1,kod);
	while((PORTC&0x0f)!=0x0f);//czekaj na puszczenie klawisza
	while((PORTC&0x0f)==0x0f);//czekaj na przycinicie klawisza
	rc5_zal1=kod;

	PosLcd(1,2);
	DispLcd("ODL1 ----    ");//zapamietanie kodu ODL1
	while(RC5==1);//czekaj na poczatek kodu
	while(1){
	kod=GetRc5();
	if(kod!=0xffff)
	break;
	}
	wys_hex((kod>>8),6,2);//kod rc5 w postaci hex
	wys_hex(kod,8,2);
	write_eeprom(2,kod>>8);
	write_eeprom(3,kod);
	while((PORTC&0x0f)!=0x0f);//czekaj na puszczenie klawisza
	while((PORTC&0x0f)==0x0f);//czekaj na przycinicie klawisza
	rc5_odl1=kod;

	PosLcd(1,2);
	DispLcd("ZAL2 ----    ");//zapamietanie kodu ZAL2
	while(RC5==1);//czekaj na poczatek kodu
	while(1){
	kod=GetRc5();
	if(kod!=0xffff)
	break;
	}
	wys_hex((kod>>8),6,2);//kod rc5 w postaci hex
	wys_hex(kod,8,2);
	write_eeprom(4,kod>>8);
	write_eeprom(5,kod);
    while((PORTC&0x0f)!=0x0f);//czekaj na puszczenie klawisza
	while((PORTC&0x0f)==0x0f);//czekaj na przycinicie klawisza
	rc5_zal2=kod;

	PosLcd(1,2);
	DispLcd("ODL2 ----    ");//zapamietanie kodu ODL2
	while(RC5==1);//czekaj na poczatek kodu
	while(1){
	kod=GetRc5();
	if(kod!=0xffff)
	break;
	}
	wys_hex((kod>>8),6,2);//kod rc5 w postaci hex
	wys_hex(kod,8,2);
	write_eeprom(6,kod>>8);
	write_eeprom(7,kod);
	while((PORTC&0x0f)!=0x0f);//czekaj na puszczenie klawisza
	while((PORTC&0x0f)==0x0f);//czekaj na przycinicie klawisza
	rc5_odl2=kod;
	
	write_eeprom(8,0x56);//znacznik zakodowanych kodw 


}
void wys_hex(unsigned char dana, char x, char y )
{	
unsigned char hex;
	PosLcd(x,y);//wpisanie adresu
	hex=dana&0xf0;//starsza czesc
	hex=hex>>4;
	 if(hex<10)
	 hex=hex+0x30;
	 else
	 hex=hex+0x37;
	 WriteRd(hex); 	
	hex=dana&0x0f;
	 if(hex<10)
	 hex=hex+0x30;
	 else
	 hex=hex+0x37;
	 WriteRd(hex);
	return;
}
void delay_ms(unsigned int msek){
	mSec=msek;
	TMR0=125;
	tms=1;
	while(tms);
}	
