#include <pic.h>
#include <stdio.h>
#include "lcd.h"
void delay_ms(unsigned int msek);
struct{
   char tms:1;
   char fl:1;
   char flt1:1;

}bits;
#define tms bits.tms
#define fl bits.fl
#define flt1 bits.flt1

#define RX_PIN TRISC7
#define TX_PIN TRISC6

unsigned char getch(void);
void putstr(const char * s); 
//obsuga przerwnia od Timer0 
unsigned int mSec,uSec;
static void interrupt
isr(void)         // przerwanie od Timer0
{
   if(T0IF){             //zerowan ie flagi przerwania
      TMR0+=131;         //8MHz/4/16/125=1kHz T=1msek
      if(tms){
      --mSec;
      if(mSec==0)
      tms=0;
      }
      T0IF = 0;         // clear the interrupt flag
   }
}

void main(void){
char c,x,y,i;
int data;
char buf[18];
	OPTION=0b00000011;//ustawienie TMR0
	T0IE = 1;		// odblokowanie przerwania od przepelnienia TMR0
	GIE = 1;		// Global interrupt enable
	ANSELH=0;		//PORTB cyfrowy 
	TRISD=0;
	InicLcd();		//inicjalizacja wyietlacza 
	//programowanie BRG
	BRGH=0;
	BRG16=0;
	SPBRG=12;	//9600Bd
	//inicjalizacja EUSART - nadajnik 
	SYNC=0;//port asynchroniczny 
	SPEN=1;//odblokowanie portu
	TXEN=1;//odblokowanie nadajnika 
	TX9=0;//dane 8 bitowe
	CREN=1;
	RX9=0;
	//while(1);
	for(i=0;i<17;i++)
	buf[i]=0x20; 
	x=1;y=2;
	while(1){
	PosLcd(x,y);	//pozycja na wywietlaczu 
	c=getch();		//odbierz znak 
	if(c>=0x20)		//wpisuj bez znakow sterujacych
	buf[x]=c;
	++x;			//nastepna pozycja na wywietlaczu 
	if(c==0x1b){	//klawisz <- kasowanie wyietlacza
	c=getch();c=getch();//odebranie 2 dodtkowych kodw
	x=1; y=2;		//ustawienie pozycji poczatkowej
	ClrLcd();		//czysczenie wywietlacza 
	continue;
	}
	
	if(x==17||c=='\r'){//sprawdzanie warunku nowej liniki na wysietlaczu 
	 putch('\n'); putch('\r');//nowa linijka w terminalu PC
	 ClrLcd();				//czysczenie wywietlacza
	 for(i=1;i<17;i++)		//przepisywanie dolnej linijki do grnej linijki LCD
	 WriteRd(buf[i]);		
	 x=1;y=2;				//nowa pozycja wywietlacza 
	 for(i=0;i<17;i++)		//czysczenie bufora wyietlacza (kody spacji)
	 buf[i]=0x20;
	 continue;
	}
	putch(c);			//odesanie znaku do terminala PC - echo
	WriteRd(c);			//wysietlenie znaku na wyietlaczu LCD. 
	
	//printf ("Test UART ZL5PIC\n\r");
	//delay_ms(50);
	}
}

void putch(unsigned char data){
	while(!TXIF)	//czekaj na mozliwo wysania bajtud
		continue;
	TXREG = data; 
}
unsigned char getch(void) {
	while(!RCIF)	//czekaj na zapenienie bufora 
		continue;
	return RCREG;	
}
void putstr(const char * s)
{
   while(*s)
   putch(*s++);
}
void delay_ms(unsigned int msek){
	mSec=msek;
	TMR0|=131;
	tms=1;
	while(tms);
}

