#include <pic.h>
#include <stdio.h>
#include "lcd.h"

struct{
   char tms:1;
	char time:1;

}bits;
#define tms bits.tms
#define time bits.time

unsigned long Time;
unsigned int mSec;

void Time_m(void);
void DispTime(unsigned long ti);

static void interrupt int_time(void) 
{

	if(INTF){
	if(time){	//pierwsze zbocze
	TMR2ON=1;	//licznik startuje
	time=0;		//wskaznik ze pierwsze zbocze zostao zarejestrowane
	}
	else{		//drugie zbocze zostao przyjete
	TMR2ON=0;	//stop zliczania impulsw
	INTE=0;		//zablokowanie przerwa zewnetrznych
	}

	INTF=0;
	}
	if(TMR2IF){
	//zliczanie przerwa pomiaru czasu
	++Time;
	TMR2IF=0;}


   	if(T0IF){             // TMR0 do odliczania opnie       
      TMR0+=131;         	//8MHz/4/16/125=1kHz T=1msek
      if(tms){
      --mSec;
      if(mSec==0)
      tms=0;
      }
      T0IF = 0;         // clear the interrupt flag
   }
}
void main(void){


	OPTION=0b00000011;//ustawienie TMR0
	T2CON=0b00100000;//ustawienie TMR2 - licznik zlicza 2MHz post skaler 5 
	ANSEL=0;
	ANSELH=0;
	PR2=39; 		//2MHz/40/5=10kHz
	T0IE = 1;		// odblokowanie przerwania od przepelnienia TMR0
	TMR2IE=1;		//odblokowanie przerwania od Timer2
	INTEDG=1;		//zbocze narastajce
	PEIE=1;
	GIE = 1;		// odblokowanie systemu przerwa
	TRISD=0;
	TRISC7=0;

	InicLcd();
	PosLcd(3,1);
	DispLcd("T=       sek ");
	PosLcd(3,2);
	DispLcd("F=         Hz");
	
	while(1){
	Time_m();
	delay_ms(100);
	}
}

void DispTime(unsigned long ti){
static bank1 char tab[20],j,i,p;
float fr;
	
	j=sprintf(tab,"%lu",ti);
	PosLcd(5,1);
	DispLcd("0,00000");
	p=11;    
	for(i=0;i<j;i++)
	{if(i==5)
	 --p;
	 PosLcd(p-i,1);
	 WriteRd(tab[j-i-1]);
	}
	if(ti==0)
	{PosLcd(3,2);
	 DispLcd("out of range");
	 return;}
	
	fr=(float)10000/(float)ti;
	j=sprintf(tab,"%fu",fr);
	PosLcd(5,2);
	if(j>10)
	j=10;
	for(i=0;i<j-1;i++)
	WriteRd(tab[i]);
	
	
	
		
}

void delay_ms(unsigned int msek){
	mSec=msek;
	TMR0|=131;
	tms=1;
	while(tms);
}

void Time_m(void){
	
	
	Time=0;
	TMR2ON=0;//zatrzymanie zliczania TMR2
	TMR2=0;	//wyserowanie TMR2
	time=1;	//odblkowanie zliczania 
	INTE=1;	//odblokowanie przerwania INT
	while(INTE);
	
	DispTime(Time);
		
}



