#include <pic.h>
#include "lcd.h"
struct{
   char tms:1;
}bits;
#define tms bits.tms

unsigned int mSec,uSec;
//obsuga przerwnia od Timer - odliczanie opnie
static void interrupt
isr(void)         		// przerwanie od Timer0
{
   if(T0IF){             //zerowan ie flagi przerwania
      TMR0+=131;         //8MHz/4/16/125=1kHz T=1msek
      if(tms){
      --mSec;
      if(mSec==0)
      tms=0;
      }
      T0IF = 0;         // clear the interrupt flag
   }
}
void main(void){
	InicLcd();
	PosLcd(1,1);
	DispLcd("Test wyswietlacza LCD");
	PosLcd(1,2);
	WriteRd ('T');


}
void DispLcd(const char * s)
{
   while(*s)
   WriteRd(*s++);
}

void ClrLcd(void)
	{WriteRi(1);}		//display clear
void InicLcd(void)		//inicjalizacja modulu LCD
{       
    RW=0;  				//zapisywanie do sterownika
    delay_ms(200);
	RS=0; 
	asm("nop"); 
	EN=0;
	WriteRiInit(3);
    WriteRiInit(3);
    WriteRiInit(3);     
    WriteRiInit(2); 
	WriteRi(0x28);
	WriteRi(8);//display off
	WriteRi(1);//display clear
	WriteRi(6);//entry mod
	WriteRi(0x0c);//display on
}
//********************************************************
//funkcja zapisania 4bitw na magistrali w czasie 
//inicjalizacji interfejsu 4 bitowego 
//zapisywana dana w zmiennej regi
//******************************************************** 
void WriteRiInit(unsigned char regi)
{	
	asm("nop"); 
	EN=1;
	asm("nop"); 
	EN=1; 
	RS=0;
	PORTD=regi;
	asm("nop"); 	
	EN=0;
	delay_ms(5); 
    }
//*********************************************************
//funkcja ustalania pocztku wywietlania
//x- pooenie w wierszu 0d 1 do 16
//y- wiersz grny 1, dolny 2
//********************************************************* 
void PosLcd(char x, char y)
{ 
  if(x<1||x>16)		//zabezpieczenie przed 
	return;			//bdnymi wsprzdnymi
	if(y!=1&&y!=2)
	return;
  --x;
  if(y==2)
  x=x+0x40;			//adres RAM drugiego wiersza
  RS=0; 			//zapisanie instrukcji
  WriteLcd(x|0x80);}//zapisz adres
//********************************************************
//funkcja zapisania rejestru danych 
//zapisywana dana w zmiennej data
//******************************************************** 
void WriteRd (unsigned char data)
{  RS=1; 
   WriteLcd(data);} 
//********************************************************
//funkcja zapisania rejestru instrukcji 
//zapisywana dana w zmiennej regi
//******************************************************** 
void WriteRi(unsigned char regi)
{      RS=0;	
	   WriteLcd(regi);}
//********************************************************
//funkcja zapisania danej na magistral 
//zapisywana dana w zmiennej data
//przed wywyolniem musi byc ustalony stan linii RS
//RS=1 dane RS=0 instrukcje
//******************************************************** 
void WriteLcd(unsigned char data)
{
unsigned char pom;

	EN=1;
	PORTD=PORTD&0xf0;
	PORTD=PORTD|(data>>4);//zapisanie 4 starszych bitw

    EN=0;
	asm("nop"); 
	EN=1;
	PORTD=PORTD&0xf0;
	PORTD=PORTD|(data&0x0f);//zapisanie 4 modszych bitw
	asm("nop"); 
	EN=0;
	delay_ms(2);
}
//zdefiniowanie znaku stopnia
void DefLcdChar(void)
{
	WriteRi(0x40);//adres 00 w pamieci CG RAM
	WriteRd(0x06);
	WriteRd(0x09);
	WriteRd(0x09);
	WriteRd(0x06);
	WriteRd(0x00);
	WriteRd(0x00);
	WriteRd(0x00);
	WriteRd(0x00);
}

void delay_ms(unsigned int msek){
	mSec=msek;
	TMR0|=131;
	tms=1;
	while(tms);
}
