#include <pic.h>
#include "i2c.h"
#define DAT 1
#define REGS 0
#define TH 2	//pointer THYST
#define TS 3	//pointer TSET

#define RS RC0
#define E RC1  
#define RW RC2 
#define CS2 RC5 //{output_bit (PIN_C5,0);delay_us(DL);}
#define CS1 RC6 //{output_bit (PIN_C6,0);delay_us(DL);}
#define RES RC7 //{output_bit (PIN_C7,0);delay_us(DL);}
void WriteLcd(unsigned char reg, unsigned char dana);
unsigned char ReadStatus(void);
void ClrLcd(void);
void LcdWriteData(unsigned char data, unsigned char column, unsigned char page);
void LcdTxt(const char * s,char x, char y);
char WriteChar(char code,unsigned char col,unsigned char page);
void PosLcd(unsigned char x, unsigned char y);
void InicLcd(void);
void DispDec(unsigned char data, unsigned char x, unsigned char y);
void DispTemp(unsigned char x, unsigned char y);
void WriteConfig(unsigned char config);
void WriteTemp(unsigned char pointer, unsigned int temp);
unsigned int ReadTemp(void);
char SelFun(void);
unsigned char SetMonth(void);
unsigned char col,page, atr;
void delay_ms(unsigned int msek);
void delay(void);

struct{
   char tms:1;
}bits;
#define tms bits.tms
unsigned int mSec,uSec;
//obsuga przerwnia od Timer - odliczanie opnie
static void interrupt
isr(void)         		// przerwanie od Timer0
{
   if(T0IF){             //zerowan ie flagi przerwania
      TMR0+=131;         //8MHz/4/16/125=1kHz T=1msek
      if(tms){
      --mSec;
      if(mSec==0)
      tms=0;
      }
      T0IF = 0;         // clear the interrupt flag
   }
}

void main(void){
unsigned char fun;
	OPTION=0b00000011;//ustawienie TMR0
	T0IE = 1;		// odblokowanie przerwania od przepelnienia TMR0
	GIE = 1;		// Global interrupt enable
	ANSELH=0;		//PORTB cyfrowy 
	ANSEL=0;		//PORTA cyfrowy 
	TRISC=0;
	TRISA=0xff;
	InicLcd();
	delay_ms(50);
	WriteConfig(0);
	WriteTemp(TH,47);
	WriteTemp(TS,48);
	while(1){
	fun=SelFun();
	if(fun==5)
	SetMonth();
	}
	while(1){
	DispTemp(0,0);
	if(!RB4)
	LcdTxt("ALARM",13,0);
	else
	LcdTxt("     ",13,0);
	delay_ms(300);
	}
}
//****************************************************************
// funkcja zerowania zawartoci RAM obu strerownikw KS0108
//****************************************************************
void ClrLcd(void){
unsigned char i,j;
	CS1=1;					//sterownik lewej poowy wywietlacza  
	for(i=0;i<8;i++)
    {WriteLcd(REGS,0xb8|i);//ustawienie strony 
	for(j=0;j<64;j++)
	WriteLcd(DAT,0);}		//zerowanie pamici 
	CS1=0;
	delay();
	CS2=1; 					//sterownik prawej czsci wywietlacza
	for(i=0;i<8;i++){
	WriteLcd(REGS,0xb8|i);
	for(j=0;j<64;j++)
	WriteLcd(DAT,0);}
	CS2=0;

}
void InicLcd(){
	CS1=0; 
	CS2=0;
	RES=0;
	delay_ms(5);
	RES=1;
	delay();
	CS1=1;
	WriteLcd(REGS,0x3f);//LCD ON
	WriteLcd(REGS,0xc0);//pierwsza lini
	CS1=0;
	delay();
	CS2=1;
	WriteLcd(REGS,0x3f);//LCD ON
	WriteLcd(REGS,0xc0);//pierwsza linia
	CS1=0;
}
//*****************************************************************
//funkcja zapisania danych przez ,magistral  wyswietlacza
//dana jest w argumencie dana, a typ rejestru: sterujcy/dana RAM
//*****************************************************************
void WriteLcd(unsigned char reg, unsigned char dana){
	if(reg==REGS)
	RS=0;	 //zapisanie rejestru sterujcego
	else
	RS=1;	//zapisanie pamici RAM wywietlacza
	delay();
	E=0;		//E=0
	delay();
	RW=0;		//RW=0
	delay();
	E=1;		//E=1
    delay();
	TRISD=0;
	PORTD=dana;
	delay();
	E=0;		//E=0
	while((ReadStatus()&0x80)==0x80);//czekaj na wyzerowanie flagi BUSY
}
//*****************************************************************
//funkcja odczytywania rejestru statusowego
//*****************************************************************
unsigned char ReadStatus(void){
unsigned char data;
	E=0;		//E=0
	delay();
	RS=0;		//odczytanie  rejestru statusowego
	delay();
	RW=1;		//RW=1 - odczytanie
	delay();
	TRISD=0xff;	//dane wejciowe
	E=1;		//E=1
	delay();
	TRISD=0xff;
	data=PORTD;//zapisanie danych z magistrali do data
	delay();
	E=0;
	return(data);
}
void PosLcd(unsigned char x, unsigned char y){
	page=y;
	col=x*7;
}
char SelFun(){
unsigned char pos_menu,kl;
	pos_menu=0;
	ClrLcd();
	atr=0;
	LcdTxt("MENU",0,0);
	while(1){	
	if(pos_menu==0)
	atr=1;
	else
	atr=0;
	LcdTxt("Ustaw Tset        ",0,1);
	if(pos_menu==1)
	atr=1;
	else
	atr=0;
	LcdTxt("Ustaw Thyst       ",0,2);
	if(pos_menu==2)
	atr=1;
	else
	atr=0;
	LcdTxt("Ustaw godziny     ",0,3);
	if(pos_menu==3)
	atr=1;
	else
	atr=0;
	LcdTxt("Ustaw dni tygodnia",0,4);
	if(pos_menu==4)
	atr=1;
	else
	atr=0;
	LcdTxt("Ustaw dni miesiaca",0,5);
	if(pos_menu==5)
	atr=1;
	else
	atr=0;
	LcdTxt("Ustaw miesiac      ",0,6);
	while((PORTA&0x1f)==0x1f);	//klawisz zosta naciniety
	delay_ms(30);
	kl=(~(PORTA)&0x1f);
	if(kl==4)
	{++pos_menu;
	 if(pos_menu==6)
     pos_menu=0;
	}
	if(kl==2)
	{--pos_menu;
	 if(pos_menu==0xff)
     pos_menu=5;
	}
	if(kl==0x10){
	ClrLcd();
	atr=0;
	return(pos_menu);
	}
	}
	return(0);
}

unsigned char  SetMonth(){
char month=0;
unsigned char kl;
	ClrLcd();
	atr=0;
	while(1){
	if(month==0)
	 atr=1;
	 else
	 atr=0;
	 LcdTxt("Styczen ",0,0);
	 
	 if(month==1)
	 atr=1;
	 else
	 atr=0;
	 LcdTxt("Luty    ",8,0);
     
	 if(month==2)
	 atr=1;
	 else
	 atr=0;
	 LcdTxt("Marzec  ",0,1);

	 if(month==3)
	 atr=1;
	 else
	 atr=0;
	 LcdTxt("Kwiecien ",8,1);

	if(month==4)
	 atr=1;
	 else
	 atr=0;
	 LcdTxt("Maj     ",0,2);

	if(month==5)
	 atr=1;
	 else
	 atr=0;
	 LcdTxt("Czerwiec ",8,2);
	 
	 if(month==6)
	 atr=1;
	 else
	 atr=0;
	 LcdTxt("Lipiec  ",0,3);
	
	 if(month==7)
	 atr=1;
	 else
	 atr=0;
	 LcdTxt("Sierpien  ",8,3);

	 if(month==8)
	 atr=1;
	 else
	 atr=0;
	 LcdTxt("Wrzesien",0,4);

	 if(month==9)
	 atr=1;
	 else
	 atr=0;
	 LcdTxt("Pazdzierni",8,4);

	if(month==10)
	 atr=1;
	 else
	 atr=0;
	 LcdTxt("Listopad ",0,5);

	if(month==11)
	 atr=1;
	 else
	 atr=0;
	 LcdTxt("Grudzien   ",8,5);

	while((PORTA&0x1f)==0x1f);	//klawisz zosta naciniety
	delay_ms(30);
	kl=(~(PORTA)&0x1f);
	if(kl==4)
	{month=month+2;
	 if(month>11)
     month=0;
	}
	if(kl==2)
	{month=month-2;
	 if(month>=254)
     month=10;
	}
	if(kl==8)
	{month=month+1;
	 if(month>11)
     month=0;
	}
	if(kl==1)
	{month=month-1;
	 if(month>=254)
     month=11;
	}
	if(kl==0x10){
	ClrLcd();
	atr=0;
	return(month);
	}
	}
	return(0); 
	
}

/************************************************************
zapisanie danej do sterownika wywietlacza po lokacj okrelon
przez wsprzdne x(piksel w wiersszu) i y (wiersz(
**************************************************************/

void LcdWriteData(unsigned char data, unsigned char column, unsigned char page){
 	page&=7;
	if(column>63)
	{CS2=1;
	 WriteLcd(REGS,page|0xb8);//adres strony - wiersz
     WriteLcd(REGS,(column-64)|0x40);//kolumna - piksel w wierszu
	 if(atr==0)
     WriteLcd(DAT,data);
	else
	 WriteLcd(DAT,~data);
     CS2=0;}
	else
	{CS1=1;
	 WriteLcd(REGS,page|0xb8);//adres strony - wiersz
     WriteLcd(REGS,column|0x40);//kolumna - piksel w wierszu
     if(atr==0)
     WriteLcd(DAT,data);
	else
	 WriteLcd(DAT,~data);
     CS1=0;}
	
}

/*************************************************************
funkcja odczytania temperatury otoczenia dla
9 bitowej rodzielczoci pomiaru
/*************************************************************/
unsigned int ReadTemp(){
unsigned int data;
	i2c_start();
	i2c_write(0x90);	//adres slave R/W=0
	i2c_write(0);    	//pointer TA (otoczenia)
	i2c_start();		//powtrzony start
	i2c_write(0x91);	//adres slave R/W=1
	data=i2c_read(1);	//starsze 8 bitw TA
	data=data<<8;
	data=data|i2c_read(0);//modsze 8 bitw TA z bitem NAK
	i2c_stop();
	return(data>>7);	//bity od pozycji b0
}
/*************************************************************
funkcja zapisania rejestru konfiguracyjnego CONFIG
/*************************************************************/
void WriteConfig(unsigned char config){
	i2c_start();
	i2c_write(0x90);	//adres slave R/W=0
	i2c_write(1);		//pointer CONFIG
	i2c_write(config);
	i2c_stop();
}
/*************************************************************
funkcja zapisania temperatury TSET i THYST
temperatura zawarta jest w argumencie temp
/*************************************************************/
void WriteTemp(unsigned char pointer, unsigned int temp){
	temp=temp<<7;
	i2c_start();
	i2c_write(0x90);	//adres slave R/W=0
	i2c_write(pointer);		//pointer CONFIG
	i2c_write(temp>>8);
	i2c_write(temp);
	i2c_stop();
}
/*************************************************************
funkcja konwersji temperatury na warto bezwzgldn  
zwracana jest 8 bitowa warto bezwzgldna ze z informacj o czci uamkowej 
na 9-tym bicie
/*************************************************************/
unsigned int KonwTemp(unsigned int temp){
unsigned char u,t;
unsigned int Tmp=0;
	t=temp;			//w zmiennej t tylko 8 modszych bitw ( konwersja typw)
	if((temp&0x100)==0x100) //czy warto ujemna
	t=(~t)+1;		//konwersja U2 na warto bezwzgldn 
	u=t%2;			// dzielenie modulo 2	
	t=t/2;			//modu wartoci cakowitej temperatury		 
	if(u==1)
	Tmp=Tmp|0x0100; //b8=1  jest cz uamkowa 0,5C
	Tmp=Tmp|t;		//dopisanie moduu wartoci cakowitej temperatury
	return(Tmp);
}

/**************************************************
funkcja wywietlania temperatury na wywietlaczu 
graficznym. Wywietlane s 2 cyfry czci cakowitej
(zakres 0099) i cz uamkowa 0,5C
/**************************************************/
void DispTemp(unsigned char x,unsigned char y)
{
unsigned int tmp,temp;
	LcdTxt("Twewn ",x,y);
	x=x+5;
	temp=ReadTemp();
	if((temp&0x0100)==0)	//sprawdzenie znaku temperatury
	WriteChar('+',x,y);
	else
	WriteChar('-',x,y);
	tmp=KonwTemp(temp);		//wykonanie konwersji 
	DispDec(tmp,x+1,y);		//wywietlenie 2 cyfr czci cakowitej
	WriteChar(',',x+3,y);	//wywietlenie znaku przecinka
	if((tmp&0xff00)>0)		//sprawdzenie czy jest cz uamkowa
	WriteChar('5',x+4,y);	//wywietlenie znaku 5  cze uamkowa
	else
	WriteChar('0',x+4,y);
	WriteChar(21,x+5,y);		//wywietlenie znaku stopnia
	WriteChar('C',x+6,y);
}
//wysietlenie wartoci data w postaci 2 cyfr dziesietnie 00hex....99hex 
void DispDec(unsigned char data, unsigned char x, unsigned char y){
	WriteChar(((data/10)+0x30),x,y);
    WriteChar(((data%10)+0x30),x+1,y);
	 	
}
const char rom_gen[]={
0x48,0x54,0x56,0x54,0x20,0,//kod 
0x20,0x54,0x54,0xd4,0x78,0,//kod 
0x38,0x44,0x46,0x44,0x20,0,//kod 
0x00,0x00,0x00,0x00,0x00,0,//kod 3
0x00,0x00,0x00,0x00,0x00,0,//kod 4
0x00,0x00,0x00,0x00,0x00,0,//kod 5
0x00,0x00,0x00,0x00,0x00,0,//kod 6
0x00,0x00,0x00,0x00,0x00,0,//kod 7
0x00,0x00,0x00,0x00,0x00,0,//kod 8
0x00,0x00,0x00,0x00,0x00,0,//kod 9
0x00,0x00,0x00,0x00,0x00,0,//kod A
0x00,0x00,0x00,0x00,0x00,0,//kod B
0x00,0x00,0x00,0x00,0x00,0,//kod 12
0x00,0x00,0x00,0x00,0x00,0,//kod 13
0x00,0x00,0x00,0x00,0x00,0,//kod 14
0x00,0x00,0x00,0x00,0x00,0,//kod 15
0x00,0x00,0x00,0x00,0x00,0,//kod 16
0x00,0x00,0x00,0x00,0x00,0,//kod 17
0x00,0x00,0x00,0x00,0x00,0,//kod 18
0x00,0x00,0x00,0x00,0x00,0,//kod 19
0x00,0x00,0x00,0x00,0x00,0,//kod 20
0x00,0x06,0x09,0x09,0x06,0,//kod 21 stopnie C
0x2a,0x1c,0x3e,0x1c,0x2a,0,//kod 22 (sloneczko)
0x24,0x46,0x46,0x3e,0x06,0x04,//kod 23(parasolka)
0,0xc0,0xe0,0xf0,0xc8,0x88,//kod 24 (szpula magnet)
0x88,0xc8,0xf0,0xe0,0xc0,0,//kod 25
0,0xc0,0x20,0x10,0x38,0xf8,//kod 26
0xf8,0x38,0x10,0x20,0xc0,0,//kod 27
0x00,0x03,0x04,0x08,0x1c,0x1f,//kod 28
0x1f,0x1c,0x08,4,3,0,//kod 29
0,3,7,0x0f,0x13,0x11,//kod 30
0x11,0x13,0x0f,7,3,0,//kod 31
0x00,0x00,0x00,0x00,0x00,0,//kod spacja
0,0,0xf2,0,0,0,//kod !
0,3,0,3,0,0,//kod "
0x14,0x7f,0x14,0x7f,0x14,0,//kod #
0x24,0x2a,0x7f,0x2a,0x12,0,//kod $
0x23,0x13,8,0x64,0x62,0,//kod %
0x36,0x49,0x55,0x22,0x50,0,//kod &
0,5,3,0,0,0,//kod '
0,0x1c,0x22,0x41,0,0,//kod (
0,0x41,0x22,0x1c,0,0,//kod )
0x14,8,0x3e,8,0x14,0,//kod *
8,8,0x3e,8,8,0,//kod 
0,0x50,0x30,0,0,0,//kod ,
8,8,8,8,8,8,//kod -
0,0x60,0x60,0,0,0,//kod .
0x20,0x10,8,4,2,0,//kod /
0x3e,0x51,0x49,0x45,0x3e,0,//kod 0
0,0x42,0x7f,0x40,0,0,//kod 1
0x42,0x61,0x51,0x49,0x46,0,//kod 2
0x21,0x41,0x45,0x4b,0x31,0,//kod 3
0x18,0x14,0x12,0x7f,0x10,0,//kod 4
0x27,0x45,0x45,0x45,0x39,0,//kod 5
0x3c,0x4a,0x49,0x49,0x30,0,//kod 6
1,0x71,9,5,3,0,//kod 7
0x36,0x49,0x49,0x49,0x36,0,//kod 8
6,0x49,0x49,0x29,0x1e,0,//kod 9
0,0x36,0x36,0,0,0,//kod :
0,0x56,0x36,0,0,0,//kod ;
8,0x14,0x22,0x41,0,0,//kod <
0x14,0x14,0x14,0x14,0x14,0x00,//kod=
0,0x41,0x22,0x14,8,0,//kod >
2,1,0x51,9,6,0,//kod ?
0x30,0x49,0x79,0x41,0x3e,0,//kod @
0x7E,0x11,0x11,0x11,0x7E,0x00,
0x7F,0x49,0x49,0x49,0x36,0x00,
0x3E,0x41,0x41,0x41,0x22,0x00,
0x7F,0x41,0x41,0x22,0x1C,0x00,
0x7F,0x49,0x49,0x49,0x41,0x00,
0x7F,0x09,0x09,0x09,0x01,0x00,
0x3E,0x41,0x49,0x49,0x7A,0x00,
0x7F,0x08,0x08,0x08,0x7F,0x00,
0x00,0x41,0x7F,0x41,0x00,0x00,
0x20,0x40,0x41,0x3F,0x01,0x00,
0x7F,0x08,0x14,0x22,0x41,0x00,
0x7F,0x40,0x40,0x40,0x40,0x00,
0x7F,0x02,0x0C,0x02,0x7F,0x00,
0x7F,0x04,0x08,0x10,0x7F,0x00,
0x3E,0x41,0x41,0x41,0x3E,0x00,
0x7F,0x09,0x09,0x09,0x06,0x00,
0x3E,0x41,0x51,0x21,0x5E,0x00,
0x7F,0x09,0x19,0x29,0x46,0x00,
0x46,0x49,0x49,0x49,0x31,0x00,
0x01,0x01,0x7F,0x01,0x01,0x00,
0x3F,0x40,0x40,0x40,0x3F,0x00,
0x1F,0x20,0x40,0x20,0x1F,0x00,
0x3F,0x40,0x38,0x40,0x3F,0x00,
0x63,0x14,0x08,0x14,0x63,0x00,
0x07,0x08,0x70,0x08,0x07,0x00,
0x61,0x51,0x49,0x45,0x43,0x00,
0x00,0x7F,0x41,0x41,0x00,0x00,
0x02,0x04,0x08,0x10,0x20,0x00,
0x00,0x41,0x41,0x7F,0x00,0x00,
0x04,0x02,0x01,0x02,0x04,0x00,
0x40,0x40,0x40,0x40,0x40,0x00,
0x00,0x01,0x02,0x04,0x00,0x00,
0x20,0x54,0x54,0x54,0x78,0x00,
0x7F,0x48,0x44,0x44,0x38,0x00,
0x38,0x44,0x44,0x44,0x20,0x00,
0x38,0x44,0x44,0x48,0x7F,0x00,
0x38,0x54,0x54,0x54,0x18,0x00,
0x08,0x7E,0x09,0x01,0x02,0x00,
0x0C,0x52,0x52,0x52,0x3E,0x00,
0x7F,0x08,0x04,0x04,0x78,0x00,
0x00,0x44,0x7D,0x40,0x00,0x00,
0x20,0x40,0x44,0x3D,0x00,0x00,
0x7F,0x10,0x28,0x44,0x00,0x00,
0x00,0x41,0x7F,0x40,0x00,0x00,
0x7C,0x04,0x18,0x04,0x78,0x00,
0x7C,0x08,0x04,0x04,0x78,0x00,
0x38,0x44,0x44,0x44,0x38,0x00,
0x7C,0x14,0x14,0x14,0x08,0x00,
0x08,0x14,0x14,0x18,0x7C,0x00,
0x7C,0x08,0x04,0x04,0x08,0x00,
0x48,0x54,0x54,0x54,0x20,0x00,
0x04,0x3F,0x44,0x40,0x20,0x00,
0x3C,0x40,0x40,0x20,0x7C,0x00,
0x1C,0x20,0x40,0x20,0x1C,0x00,
0x3C,0x40,0x30,0x40,0x3C,0x00,
0x44,0x28,0x10,0x28,0x44,0x00,
0x0C,0x50,0x50,0x50,0x3C,0x00,
0x44,0x64,0x54,0x4C,0x44,0x00,
0x00,0x08,0x36,0x41,0x00,0x00,
0x00,0x00,0x7F,0x00,0x00,0x00,
0x00,0x41,0x36,0x08,0x00,0x00,
0x10,0x08,0x08,0x10,0x08,0x00,
0x78,0x46,0x41,0x46,0x78,0x00,
};

void WrChar(char code)
{
unsigned int code_point;
	//col=col*7;		
	if((col+6)>121)
	return;//ten znak sie nie zmiesci
	code_point=(code*6);
	LcdWriteData(rom_gen[code_point++],col++,page);
	LcdWriteData(rom_gen[code_point++],col++,page);
	LcdWriteData(rom_gen[code_point++],col++,page);
	LcdWriteData(rom_gen[code_point++],col++,page);
	LcdWriteData(rom_gen[code_point++],col++,page);
	LcdWriteData(rom_gen[code_point],col++,page);
}

char WriteChar(char code,unsigned char col,unsigned char page)
{
unsigned char code_point;
	col=col*7;		
	if((col+6)>121)
	return(0);//ten znak sie nie zmiesci
	code_point=(code*6);
	LcdWriteData(rom_gen[code_point++],col++,page);
	LcdWriteData(rom_gen[code_point++],col++,page);
	LcdWriteData(rom_gen[code_point++],col++,page);
	LcdWriteData(rom_gen[code_point++],col++,page);
	LcdWriteData(rom_gen[code_point++],col++,page);
	LcdWriteData(rom_gen[code_point],col,page);
	return(1);
}


//wyswietla ciag zankow ascii	

void LcdTxt(const char * s, char x, char y)
{
	PosLcd(x,y);
   	while(*s)
  	WrChar(*s++);
}
void delay_ms(unsigned int msek){
	mSec=msek;
	TMR0|=131;
	tms=1;
	while(tms);
}
void delay(void){
	asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");
	asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");
	asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");

}






